%define name smeserver-apache-tomcat
%define version 5.5.23
%define release 2
%define rpmver  4.0.4

Summary:            Apache Tomcat is the servlet container
Name:               %{name}
Version:            %{version}
Release:            %{release}
Copyright:          GPL
Group:              Apache/add-on
Source:             %{name}-%{version}.tar.gz
Packager:           Sylvain Gomez  <sylvaingomez@free.fr>
URL:                http://tomcat.apache.org/
BuildRoot:          /var/tmp/%{name}-%{version}-%{release}-buildroot
BuildArchitectures: i386
Requires:           e-smith-base, e-smith-release >= 7, jdk >= 1_5_0

%description
This RPM is an unofficial addon for the SME Server 7.x.
Apache Tomcat is the servlet container that is used in the official Reference Implementation for the
Java Servlet and JavaServer Pages technologies. The Java Servlet and JavaServer Pages specifications
are developed by Sun under the Java Community Process.
http://your_e-smith-server_name:8181

%changelog
* Thu Jun 28 2007 Sylvain Gomez <sylvaingomez@free.fr>
- 5.5.23-2
- Added link to jdk directory
- Added binaries for mod_jk v1.2.23 (Tomcat/Apache connector)
- Added templates for mod_jk and Tomcat's default servlets
- Added expand and restart Apache for tomcat-update event
- Changed rpm architecture from noarch to i386

* Wed Jun 27 2007 Sylvain Gomez <sylvaingomez@free.fr>
- 5.5.23-1
- Original version

%prep
rm -rf $RPM_BUILD_ROOT

%setup

%build

%install
/bin/rm -rf $RPM_BUILD_ROOT
(/usr/bin/find . -depth -print | /bin/cpio -dump $RPM_BUILD_ROOT)
/bin/rm -f %{name}-%{version}-filelist
/sbin/e-smith/genfilelist $RPM_BUILD_ROOT > %{name}-%{version}-filelist

%files -f %{name}-%{version}-filelist

%defattr(-,root,root)

%clean 
rm -rf $RPM_BUILD_ROOT

%pre

%post
# Adding tomcat to SME's db
/etc/e-smith/events/actions/initialize-default-databases
echo " "

# Variables
SRVNAME=$(/sbin/e-smith/db configuration get SystemName)
TOMCATPASS=$(/sbin/e-smith/db configuration getprop tomcat UserPassword)

echo "Decompressing files..."
cd /opt/tomcat
tar -xzf apache-tomcat-5.5.23.tar.gz
tar -xzf apache-tomcat-5.5.23-admin.tar.gz
rm -f apache-tomcat-5.5.23.tar.gz
rm -f apache-tomcat-5.5.23-admin.tar.gz
ln -s /opt/tomcat/apache-tomcat-5.5.23 /opt/tomcat/tomcat
mv -f /opt/tomcat/tomcat-users.xml /opt/tomcat/tomcat/conf/tomcat-users.xml

echo "Creating link to jdk directory..."
for version in `ls /usr/java/ | grep jdk1.5` ; do
JDKDIR=$version
done
echo "Found Java $JDKDIR !"
ln -s -f $JDKDIR /usr/java/jdk

echo "Creating user and group tomcat..."
groupadd tomcat
useradd -g tomcat -c 'Apache Tomcat' -d /opt/tomcat/ tomcat -p '$TOMCATPASS'
chown -R tomcat:tomcat /opt/tomcat/tomcat/
chmod 770 /opt/tomcat/tomcat

echo "Creating service..."
ln -s /etc/rc.d/init.d/tomcat /etc/rc.d/rc7.d/S98tomcat
ln -s /etc/rc.d/init.d/tomcat /etc/rc.d/rc6.d/K02tomcat
ln -s /etc/rc.d/init.d/tomcat /etc/rc.d/rc2.d/K02tomcat
ln -s /etc/rc.d/init.d/tomcat /etc/rc.d/rc1.d/K02tomcat
ln -s /etc/rc.d/init.d/tomcat /etc/rc.d/rc0.d/K02tomcat
/sbin/e-smith/db configuration setprop tomcat status enabled TCPPort 8181 access local
/sbin/e-smith/signal-event remoteaccess-update

echo " "
echo "-------------------------------------------------------------------------------"
echo "Apache Tomcat Server installation finished."
echo "You can access to Tomcat at: http://$SRVNAME:8181 by default"
echo " "
echo "Default user and password for protected panels are:"
echo "login: admin"
echo "pass : admin"
echo "Please modify admin's password in /opt/tomcat/tomcat/conf/tomcat-users.xml first!"
/sbin/e-smith/signal-event tomcat-update
echo " "
/sbin/e-smith/config show tomcat
echo "-------------------------------------------------------------------------------"

%preun
echo "Unregistering and deleting service..."
/etc/rc7.d/S98tomcat stop
rm -f /etc/rc.d/rc7.d/S98tomcat
rm -f /etc/rc.d/rc6.d/K02tomcat
rm -f /etc/rc.d/rc2.d/K02tomcat
rm -f /etc/rc.d/rc1.d/K02tomcat
rm -f /etc/rc.d/rc0.d/K02tomcat
/sbin/e-smith/config delete tomcat

%postun
echo "Restarting Apache..."
/sbin/e-smith/expand-template /etc/httpd/conf/httpd.conf
/etc/rc7.d/S86httpd-e-smith sigusr1

echo "Deleting install directory..."
rm -rf /opt/tomcat

echo "Deleting user and group tomcat..."
userdel tomcat

echo " "
echo "Uninstall finished !"
echo "You should delete manually the link /usr/java/jdk if you don't use it anymore..."
echo " "
echo " "
